/**************************************************************************/
/*                                                                        */
/*                                 Sources                                */
/*                                from  the                               */
/*                           XSC SOFTWARE PACKAGE                         */
/*                                                                        */
/*                Copyright (c) 1997 University of Karlsruhe              */
/*                     Institute for Appl. Mathematics                    */
/*                                                                        */
/* This program is free software for non-commercial use. For details, see */
/* the file LICENSE.XSC, distributed with this software package.          */
/*                                                                        */
/* This program is distributed WITHOUT ANY WARRANTY. For details, see the */
/* file LICENSE.XSC, distributed with this software package.              */
/*                                                                        */
/**************************************************************************/

/* RCS $Id: y_vlcp.c,v 1.2 1997/09/25 18:27:05 ae59 Exp $ */
/*
$Log: y_vlcp.c,v $
 * Revision 1.2  1997/09/25  18:27:05  ae59
 * Copyright-message
 *
 * Revision 1.1  1994/01/27  13:26:00  ae59
 * Put under RCS control
 *
 */
/****************************************************************/
/*                                                              */
/*      Filename        : y_vlcp.c                              */
/*                                                              */
/*      Entry           : void y_vlcp(d)                        */
/*                        y_dscp d;                             */
/*                                                              */
/*      Arguments       : d - descriptor of dynamic array       */
/*                                                              */
/*      Description     : copy value-parameter if destroy-flag  */
/*                        is FALSE, otherwise set destroy-flag  */
/*                        FALSE                                 */
/*                                                              */
/*      Date            : 1993-10-27                            */
/*      1993-10-27 : replace y_alck with y_aled   =b=           */
/*      1993-01-19 : check if dyn arrary is alloc.=b=           */
/*      1992-07-22 : (size_t) for stride                        */
/*      1991-10-10 : (char *) for malloc()                      */
/*      1991-05-29 : descrtype * replaced by y_dscp             */
/*      1991-01-17 : type of variable n -> size_t               */
/*      1990-11-12 : E_TPUSH+E_TPOPP                            */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif

#ifdef LINT_ARGS
local void y_vlcp(y_dscp d)
#else
local void y_vlcp(d)

y_dscp d;
#endif
        {
        char *p;
        size_t n;
        a_intg i,k,*help,prod;

        E_TPUSH("y_vlcp")

        if (((y_desc *)d)->destroy==FALSE)
           {
           if ((p = (char *)malloc(n =
                    ((y_desc *)d)->elsize*((y_desc *)d)->elnum))==NULL)
              {
              e_trap(ALLOCATION,2,E_TMSG,42);
              }
           else
              {
#ifdef HEAP_CHECK
b_geth((a_char *)&((y_desc *)d)->array,(a_char *)p,(a_char *)"y_vlcp");
#endif
              /* check if d is allocated */
		    if (!y_aled(d) )
		    {
                    e_trap(ALLOCATION,2,E_TMSG,42);
                    E_TPOPP("y_vlcp")
                    return;
		    }
              if (((y_desc *)d)->subarr==FALSE)
                 C_COPY(p,(char *)((y_desc *)d)->array,n)

              /* copy individual components if source is subarray  */
              else
                 {

                 /* Allocate index array help.  */
                 if ((help =
            (a_intg *)malloc(((y_desc *)d)->numdim*sizeof(a_intg)))==NULL)
                    {
                    e_trap(ALLOCATION,2,E_TMSG,42);
                    E_TPOPP("y_vlcp")
                    return;
                    }
#ifdef HEAP_CHECK
b_geth((a_char *)&help,(a_char *)help,(a_char *)"y_vlcp");
#endif
                 for (i=0;i<((y_desc *)d)->numdim;i++)
                    help[i] = ((y_desc *)d)->fd[i].lbound;

                 for (k=0;k<((y_desc *)d)->elnum;k++)
                    {
                    prod = 0;
                    for (i=0;i<((y_desc *)d)->numdim;i++)
                       prod += (help[i]-((y_desc *)d)->fd[i].lbound)*
                               ((y_desc *)d)->fd[i].stride;

                    C_COPY((char *)p+k*((y_desc *)d)->elsize,
                           (char *)((y_desc *)d)->array+
prod*((y_desc *)d)->elsize,((y_desc *)d)->elsize)

                    for (i=((y_desc *)d)->numdim-1;i>=0;i--)
                       if (++help[i]>((y_desc *)d)->fd[i].ubound)
                          help[i] = ((y_desc *)d)->fd[i].lbound;
                       else break;
                    }
#ifdef HEAP_CHECK
b_freh((a_char *)&help,(a_char *)help,(a_char *)"y_vlcp");
#endif
                 B_FREE(help)

                 /* determine strides for destination   */
                 i = ((y_desc *)d)->numdim-1;
                 ((y_desc *)d)->fd[i--].stride = 1;
                 for (;i>=0;i--)
                    {
                    ((y_desc *)d)->fd[i].stride = (size_t) (
                                      (((y_desc *)d)->fd[i+1].ubound-
                                       ((y_desc *)d)->fd[i+1].lbound+1)*
                                      ((y_desc *)d)->fd[i+1].stride);
                    }

                 ((y_desc *)d)->subarr = FALSE;
                 }

              /* if (y_aled(d) ) y_free(d);*/
              ((y_desc *)d)->array = p;
              }
           }
        else
            ((y_desc *)d)->destroy = FALSE;

        E_TPOPP("y_vlcp")
        }
